//+------------------------------------------------------------------+
//|                                        Sibbet's Demand Index.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     DeepSkyBlue
#property indicator_color2     PaleVioletRed
#property indicator_color3     DimGray
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_level1     0
#property indicator_levelcolor DimGray


//
//
//
//
//

extern int    Length           = 14;
extern bool   ShowIntermediate = false;
extern bool   arrowsVisible    = true;
extern string arrowsIdentifier = "SDI_Arrows";
extern color  arrowsUpColor    = DeepSkyBlue;
extern color  arrowsDnColor    = Red;
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

double sibb[];
double sibbHu[];
double sibbHd[];
double trend[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,sibbHu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,sibbHd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,sibb);
   SetIndexBuffer(3,trend);
   IndicatorShortName("Sibbet\'s Demand Index ("+Length+")");
   return(0);
}

//
//
//
//
//


int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][8];
#define _price 0
#define _range 1
#define _rngav 2
#define _volav 3
#define _prcra 4
#define _volra 5
#define _bpres 6
#define _spres 7

//
//
//
//
//

int start()
{
   double buyP,sellP,sign,constant,tempDI;
   int i,k,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      work[r][_price] = (High[i]+Low[i]+Close[i]+Close[i])/4.0;
      work[r][_range] = MathMax(High[i],High[i+1])-MathMin(Low[i],Low[i+1]);
      work[r][_rngav] = 0; for (k=0; k<Length; k++) work[r][_rngav] += work[r-k][_range]; work[r][_rngav] /= Length;
      if (r<Length)
          { work[r][_volav] = 0; for (k=0; k<Length; k++) work[r][_volav] += Volume[i+k]; work[r][_volav] /= Length;}
      else  work[r][_volav] = (work[r-1][_volav]*(Length-1)+Volume[i])/Length;
      
      //
      //
      //
      //
      //

         if (work[r][_volav]!=0) work[r][_volra] = Volume[i]/work[r][_volav];
         if (work[r][_price]!=0 && work[r-1][_price]!=0 && work[r][_rngav]!=0 && work[r][_volav]!=0) 
               work[r][_prcra] = (work[r][_price]-work[r-1][_price])/MathMin(work[r][_price],work[r-1][_price]);
         else  work[r][_prcra] = work[r-1][_prcra];
         if (work[r][_rngav]!=0)
               constant = MathMin(MathAbs(work[r][_prcra])*work[r][_price]*3.0/work[r][_rngav],88);
         else  constant = 0;
         if (constant != 0) constant = work[r][_volra]/MathExp(constant);

      //
      //
      //
      //
      //
      
         if (work[r][_prcra] > 0)
               { buyP  = work[r][_volra]; sellP = constant; }         
         else  { sellP = work[r][_volra]; buyP  = constant; }         

         work[r][_bpres] = (work[r-1][_bpres]*(Length-1.0)+buyP )/Length;
         work[r][_spres] = (work[r-1][_spres]*(Length-1.0)+sellP)/Length;

         tempDI = 1;
         sign   = 1;
            if (work[r][_spres]>work[r][_bpres])
                  { sign = -1; if (work[r][_spres]!=0) tempDI = work[r][_bpres]/work[r][_spres]; }
            else  { sign =  1; if (work[r][_bpres]!=0) tempDI = work[r][_spres]/work[r][_bpres]; }
         tempDI *= sign;

         //
         //
         //
         //
         //
        
         if (ShowIntermediate)
            sibb[i] = tempDI;
         else             
            if (tempDI<0) 
                  sibb[i] = 100*(-1-tempDI);
            else  sibb[i] = 100*(+1-tempDI);

         //
         //
         //
         //
         //

         sibbHu[i] = EMPTY_VALUE;
         sibbHd[i] = EMPTY_VALUE;
            if (sibb[i] > 0) sibbHu[i] = sibb[i];
            if (sibb[i] < 0) sibbHd[i] = sibb[i];
            
         trend[i] = trend[i+1];
         if (sibb[i]>0 && sibb[i+1]<0) trend[i] =  1;
         if (sibb[i]<0 && sibb[i+1]>0) trend[i] = -1;
         manageArrow(i);
         manageAlerts();
   }      
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]);
         if (trend[i]!=trend[i+1])
      {
         if (trend[i] ==  1) drawArrow(i,arrowsUpColor,241);
         if (trend[i] == -1) drawArrow(i,arrowsDnColor,242);
      }
     
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (trend[i] ==  1)
               ObjectSet(name,OBJPROP_PRICE1,Low[i]-gap);
         else  ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//
//
//
//



void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
            if (trend[whichBar] ==  1) doAlert(whichBar,"up");
            if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SDI - trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"SDI "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}



